local addonName, nameSpace = ...

nameSpace.MyBuddies = CreateFrame("Frame", addonName)

local MB = nameSpace.MyBuddies
local db = nil
local ver = "1.5.0-02"

MB:RegisterEvent("PLAYER_LOGIN")

MB:SetScript("OnEvent", function(self)
	MyBuddies_DB = MyBuddies_DB or {}
	nameSpace.db = MyBuddies_DB
	db = nameSpace.db
	if db.quiet == nil then db.quiet = false end
	if db.elvui == nil then db.elvui = false end
	if IsAddOnLoaded("ElvUI") then
		db.elvui = true
	else 
		db.elvui = false
	end
	MB:MyBuddies_Msg()
	MB:MyBuddies_CheckFrames()
end)

function MyBuddies_OnLoad(self)
	self:RegisterEvent("IGNORELIST_UPDATE");
	self:RegisterEvent("BN_FRIEND_LIST_SIZE_CHANGED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
end

function MyBuddies_OnEvent(event,...)
	local bnetCount = BNGetNumFriends();
		MyBuddiesCounter:SetText(bnetCount.."|cff416380/200|r");
		MyBuddiesCounter_elvui:SetText(bnetCount.."|cff416380/200|r");
end

function MyBuddiesIgnore_OnEvent(event,...)
	local IgnoreCount = C_FriendList.GetNumIgnores();
		MyBuddiesIgnoreCounter:SetText(IgnoreCount.."|cff416380/50|r");
		MyBuddiesIgnoreCounter_elvui:SetText(IgnoreCount.."|cff416380/50|r");
end

function MB:MyBuddies_Msg()
	if not db.quiet then
		if db.elvui then
			print("|cff00CCFFMy Buddies|r |cffffb700".. ver .."|r loaded")
			print("|cff00CCFFMy Buddies:|r Elvui mode |cffffb700Enabled|r")
		else
			print("|cff00CCFFMy Buddies|r |cffffb700".. ver .."|r loaded")
		end
	end
end

function MB:MyBuddies_CheckFrames()
	if db.elvui then
		MyBuddiesFrame:Hide()
		MyBuddiesIgnoreFrame:Hide()
	elseif not db.elvui then
		MyBuddiesFrame_elvui:Hide()
		MyBuddiesIgnoreFrame_elvui:Hide()
	end
end

function MB.SlashCommand(command)
	if strlower(command) == "quiet" then
		db.quiet = not db.quiet
		print("|cff00CCFFMy Buddies:|r Quieting", db.quiet and "|cffffb700Enabled|r" or "|cffffb700Disabled|r")
	elseif strlower(command) == "?" or strlower(command) == "help" then
		print("|cff00CCFFMy Buddies|r usage: |cff00CCFF/mb|r |cffffb700<option>|r or |cff00CCFF/mybuddies|r |cffffb700<option>|r")
		print("Options are:")
		print("|cffffb700quiet|r - Toggles addon quieting on/off")
		print("|cffffb700help|r or |cffffb700?|r - Displays valid commands")
	else
		print("|cff00CCFFMy Buddies:|r |cffff0000Invalid command|r")
		print("|cff00CCFFMy Buddies|r usage: |cff00CCFF/mb|r |cffffb700<option>|r or |cff00CCFF/mybuddies|r |cffffb700<option>|r")
		print("Options are:")
		print("|cffffb700quiet|r - Toggles addon quieting on/off")
		print("|cffffb700help|r or |cffffb700?|r - Displays valid commands")
	end
end

SLASH_MYBUDDIES1, SLASH_MYBUDDIES2 = "/mybuddies", "/mb"
SlashCmdList["MYBUDDIES"] = MB.SlashCommand